#include "dispatcher.h"
#include "async.h"
#include <stdio.h>

class ShutdownClass :public TimeNotify {
protected:
	int timeout, idle, noActiveObjectCount;
public:
	ShutdownClass(int limit) :timeout(limit), idle(0)
	{
		Dispatcher::the()->ioManager()->addTimer(1000, this);
		noActiveObjectCount = Object::_objectCount();
	}
	virtual ~ShutdownClass()
	{
		Dispatcher::the()->ioManager()->removeTimer(this);
	}
	void notifyTime()
	{
		if(Object::_objectCount() == noActiveObjectCount)
		{
			if(idle != timeout)
			{
				if(++idle == 1)
					fprintf(stdout,"\ntimeout .");
				else
					fprintf(stdout,".");

				if(idle == timeout) {
					Dispatcher::the()->terminate();
					fprintf(stdout," shutdown!\n");
				}

				fflush(stdout);
			}
		}
		else
		{
			if(idle > 0) fprintf(stdout,"cancel\n");
			idle = 0;
		}
	}
};

int main()
{
	Dispatcher dispatcher;
	ShutdownClass sdc(10);

	// the AsyncTest thingy is self-referencing, this means: it will
	// terminate itself when it feels this is necessary, and does not
	// need to be referenced by us
	Object_skel *sk = ObjectManager::the()->create("AsyncTest");
	assert(sk);
	sk->_release();

	Dispatcher::the()->run();
}
